#include <stdio.h>
#include <windows.h>

#define BUFF_SIZE 512
#pragma pack(1)

typedef struct _FAT16{
	unsigned char DriveNumber;			//db      0x00			;24	1	hCuԍ
	unsigned char Reserved1;			//db      0x00			;25	1	\
	unsigned char BootSignature;		//db      0x29			;26	1	gu[gʃR[h
	unsigned long VolumeID;				//dd      0x00000000	;27	4	{[S/N
	unsigned char VolumeLabel[11];		//db      "           "	;2a	11	{[
	unsigned char FileSystemLabel[8];	//db      "FAT12   "	;36	8	FAT^Cv 
} FAT16;

typedef struct _FAT32{
	unsigned long FatSize32;
	unsigned short ExtFlags;
	unsigned short VolVer;
	unsigned long RootClus;
	unsigned short FSInfo;
	unsigned short BkSec;
	unsigned long Reserved2_1;
	unsigned long Reserved2_2;
	unsigned long Reserved2_3;

	unsigned char DriveNumber;			//db      0x00			;	1	hCuԍ
	unsigned char Reserved1;			//db      0x00			;	1	\
	unsigned char BootSignature;		//db      0x29			;	1	gu[gʃR[h
	unsigned long VolumeID;				//dd      0x00000000	;	4	{[S/N
	unsigned char VolumeLabel[11];		//db      "           "	;	11	{[
	unsigned char FileSystemLabel[8];	//db      "FAT12   "	;	8	FAT^Cv 
} FAT32;


typedef struct _bpb {
	unsigned char OEMLabel[8];			//db      "test    "	;03	8	OEM/sOS.VER
	unsigned short BytePerSector;		//dw      0x0200		;0b	2	ZN^[̃oCg@ʏ512Œ
	unsigned char SectorsPerCluser;		//db      0x01			;0d	1	NX^̃ZN^[
	unsigned short ReservedSectors;		//dw      0x0001		;0e	2	NvOgpZN^[
	unsigned char NumberFATs;			//db      0x02			;10	1	FAT̐iʏ2j
	unsigned short MaxRootEntries;		//dw      0x0200		;11	2	[gfBNg̃Gg[iʏ512j
	unsigned short NumberSectors;		//dw      0x0b40		;13	2	_fBXÑZN^
	unsigned char MediaDescriptor;		//db      0xf0			;15	1	fBXN^Cv
	unsigned short SectorsPerFAT;		//dw      0x0009		;16	2	FAT̃ZN^[
	unsigned short SectorsPerTrack;		//dw      0x0012		;18	2	gbÑZN^
	unsigned short NumberHeads;			//dw      0x0002		;1a	2	wbh
	unsigned long HiddenSectors;		//dd      0x00000000	;1c	4	BZN^[
	unsigned long LargeSectors;			//dd      0x00000000	;20	4	_fBXÑZN^
	
	union fat_type{
		FAT16 fat16;
		FAT32 fat32;
	} Fat_type;
}   BPB;

BPB*bpb;

//hCu̗
void showNumDisk(){
	HKEY hKey;
	DWORD dwDisposition;
	LONG result;
	result = RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\services\\Disk\\Enum",
	0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,&dwDisposition);

	if(ERROR_SUCCESS==result){
		DWORD Data;	// "f[^̃|C^AhX󂯎
		DWORD dwSize=(int)sizeof(Data);	// f[^̃TCY

		result = RegQueryValueEx(hKey,"Count",NULL,NULL,(LPBYTE)&Data,&dwSize);

		for(unsigned int i=0;i<Data;i++){
			char key[10];
			char strdata[1024];
			DWORD dwType;		// l̎ނ󂯎
			DWORD dwSize=(int)sizeof(strdata);	// f[^̃TCY
			sprintf(key,"%d",i);
			result = RegQueryValueEx(hKey,key,NULL,&dwType,(LPBYTE)(LPCTSTR)strdata,&dwSize);
			printf("%s : %s\n",key,strdata);
		}
	}else{
		printf("hCu̗񋓂Ɏs܂B\n");
		printf("ЂƂǗ҂ƂĎsĂȂƂH\n");
	}
	//L[
	RegCloseKey(hKey);
}


int main(){
	//n[hfBXNhCu0ԃhCu@ԂChCu
	char filename[32];//="\\\\.\\PHYSICALDRIVE1";
	char buff[BUFF_SIZE]="No Data\n";

	showNumDisk();

	printf("hCu̔ԍ͂ĂB\n");
	//10iƂē
	int i;
	scanf("%d",&i);
	sprintf(filename,"\\\\.\\PHYSICALDRIVE%d",i);

	//擪ZN^512oCgǂݏo
	HANDLE hFile;
	hFile = CreateFile(filename, GENERIC_READ,FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

	if( hFile != INVALID_HANDLE_VALUE ){
		DWORD len;
		ReadFile( hFile, buff, BUFF_SIZE, &len, NULL );
	}else{
		unsigned int i=GetLastError();
		if(ERROR_ACCESS_DENIED==i){
			printf("ANZXۂ܂B\nǗ҂ƂĎsĂH\n");
		}else if(ERROR_FILE_NOT_FOUND==i){
			printf("hCu̎w肪ԈĂȂH\n");
		}else{
			printf("G[@GetLastError:0x%x\n",i);
		}
		printf("vOI܂B\n");
		system("PAUSE"); 
		return -1;
	}
	CloseHandle( hFile );


	bpb=(BPB*)&buff[3];

	if(512==bpb->BytePerSector || 
		1024==bpb->BytePerSector ||
		2048==bpb->BytePerSector ||
		4096==bpb->BytePerSector ||
		8192==bpb->BytePerSector){


		//NX^̌vZ
		unsigned int Clusters;//NX^
		unsigned int RootDirSectors = ((bpb->MaxRootEntries * 32) + (bpb->BytePerSector - 1)) / bpb->BytePerSector;
		unsigned int FATSz;
		if(bpb->SectorsPerFAT != 0){
			FATSz = bpb->SectorsPerFAT;
		}else{
			FATSz = bpb->Fat_type.fat32.FatSize32;  
		}

		unsigned int TotSec;
		if(bpb->NumberSectors != 0){
			TotSec = bpb->NumberSectors;
		}else{
			TotSec = bpb->LargeSectors;
		}
		unsigned int DataSec = TotSec - (bpb->ReservedSectors + (bpb->NumberFATs * FATSz) + RootDirSectors);
		Clusters = DataSec / bpb->SectorsPerCluser;

		printf(";NX^:%d\t",Clusters);

		//NX^FAT̔
		unsigned int FAT;
		if(Clusters<4085){
			printf("FAT12\n");
			FAT=12;
		}else if(Clusters<65525){
			printf("FAT16\n");
			FAT=16;
		}else{
			printf("FAT32\n");
			FAT=32;
		}

		printf("\n\n\nȉ`ł\n\n");
		printf("[bits 16]\n");
		printf("jmp init0\n");
		printf("nop\n");
		printf(";----------------------------------------------------------------------------\n");
		printf(";Boot Parameter Block\n");
		printf(";----------------------------------------------------------------------------\n");

		printf("OEMLabel\t\tdb\t\"");
		for(i=0;i<8;i++) printf("%c",(0x20<=bpb->OEMLabel[i] && 0x7E>=bpb->OEMLabel[i] ? bpb->OEMLabel[i] : ' '));
		printf("\"\n");

		printf("BytePerSector\t\tdw\t%d\n",bpb->BytePerSector);
		printf("SectorsPerCluser\tdb\t%d\n",bpb->SectorsPerCluser);
		printf("ReservedSectors\t\tdw\t%d\n",bpb->ReservedSectors);
		printf("NumberFATs\t\tdb\t%d\n",bpb->NumberFATs);
		printf("MaxRootEntries\t\tdw\t%d\n",bpb->MaxRootEntries);
		printf("NumberSectors\t\tdw\t%d\n",bpb->NumberSectors);
		printf("MediaDescriptor\t\tdb\t0x%x\n",bpb->MediaDescriptor);
		printf("SectorsPerFAT\t\tdw\t%d\n",bpb->SectorsPerFAT);
		printf("SectorsPerTrack\t\tdw\t%d\n",bpb->SectorsPerTrack);
		printf("NumberHeads\t\tdw\t%d\n",bpb->NumberHeads);
		printf("HiddenSectors\t\tdd\t%d\n",bpb->HiddenSectors);
		printf("LargeSectors\t\tdd\t%d\n",bpb->LargeSectors);

		if(32==FAT){
			printf("FatSize32\t\tdd\t%d\n",bpb->Fat_type.fat32.FatSize32);
			printf("ExtFlags\t\tdw\t%d\n",bpb->Fat_type.fat32.ExtFlags);
			printf("VolVer\t\t\tdw\t%d\n",bpb->Fat_type.fat32.VolVer);
			printf("RootClus\t\tdd\t%d\n",bpb->Fat_type.fat32.RootClus);
			printf("FSInfo\t\t\tdw\t%d\n",bpb->Fat_type.fat32.FSInfo);
			printf("BkSec\t\t\tdw\t%d\n",bpb->Fat_type.fat32.BkSec);
			printf("Reserved2_1\t\tdd\t%d\n",bpb->Fat_type.fat32.Reserved2_1);
			printf("Reserved2_2\t\tdd\t%d\n",bpb->Fat_type.fat32.Reserved2_2);
			printf("Reserved2_3\t\tdd\t%d\n",bpb->Fat_type.fat32.Reserved2_3);

			printf("DriveNumber\t\tdb\t0x%x\n",bpb->Fat_type.fat32.DriveNumber);
			printf("Reserved1\t\tdb\t%d\n",bpb->Fat_type.fat32.Reserved1);
			printf("BootSignature\t\tdb\t0x%x\n",bpb->Fat_type.fat32.BootSignature);
			printf("VolumeID\t\tdd\t0x%x\n",bpb->Fat_type.fat32.VolumeID);

			printf("VolumeLabel\t\tdb\t\"");
			for(i=0;i<11;i++) printf("%c",(0x20<=bpb->Fat_type.fat32.VolumeLabel[i] && 0x7E>=bpb->Fat_type.fat32.VolumeLabel[i] ? bpb->Fat_type.fat32.VolumeLabel[i] : ' '));
			printf("\"\n");

			printf("FileSystemLabel\t\tdb\t\"");
			for(i=0;i<8;i++) printf("%c",(0x20<=bpb->Fat_type.fat32.FileSystemLabel[i] && 0x7E>=bpb->Fat_type.fat32.FileSystemLabel[i] ? bpb->Fat_type.fat32.FileSystemLabel[i] : ' '));
			printf("\"\n");
		}else{
			printf("DriveNumber\t\tdb\t0x%x\n",bpb->Fat_type.fat16.DriveNumber);
			printf("Reserved1\t\tdb\t%d\n",bpb->Fat_type.fat16.Reserved1);
			printf("BootSignature\t\tdb\t0x%x\n",bpb->Fat_type.fat16.BootSignature);
			printf("VolumeID\t\tdd\t0x%x\n",bpb->Fat_type.fat16.VolumeID);

			printf("VolumeLabel\t\tdb\t\"");
			for(i=0;i<11;i++) printf("%c",(0x20<=bpb->Fat_type.fat16.VolumeLabel[i] && 0x7E>=bpb->Fat_type.fat16.VolumeLabel[i] ? bpb->Fat_type.fat16.VolumeLabel[i] : ' '));
			printf("\"\n");

			printf("FileSystemLabel\t\tdb\t\"");
			for(i=0;i<8;i++) printf("%c",(0x20<=bpb->Fat_type.fat16.FileSystemLabel[i] && 0x7E>=bpb->Fat_type.fat16.FileSystemLabel[i] ? bpb->Fat_type.fat16.FileSystemLabel[i] : ' '));
			printf("\"\n");
		}
		printf(";----------------------------------------------------------------------------\n");
		printf("init0:\n");
		printf("\tjmp 07C0h:init\n");
		printf("init:\n");
		printf("\n\n\n\n");
		printf("\ttimes 510-($-$$) db 0\n");
		printf("\tdw 0AA55h\n\n");
	}else{
		printf("FATł͂Ȃ񂶂ȂȁH\n");
	}

	//obt@̓et@Cɕۑ
	FILE * fp;
	if((fp=fopen("MBRBackup","wb"))==NULL){
		//G[
	}else{
		unsigned int WriteLen = BUFF_SIZE;//ރTCY߂
		if(WriteLen!=fwrite(buff,sizeof(char),WriteLen,fp)){
			printf("݃G[%doCg܂܂",WriteLen);
		}
		fclose(fp);
	}
	printf("vOI܂B\n");
	system("PAUSE"); 
	return 0;
}